#ifndef CHUNKRENDERER_H
#define CHUNKRENDERER_H

#include "../../engine/Mesh.h"
#include "../../engine/Shader.h"
#include "../../engine/DirectRenderer.h"
#include "../../world/IChunkListener.h"

class ChunkRenderer : public IChunkListener
{
public:
    ChunkRenderer();
    virtual ~ChunkRenderer();
    
    void renderTick(Shader& shader, DirectRenderer& dr, float lag);
    void updateChunk(Chunk& c, Chunk* north, Chunk* east, Chunk* south, Chunk* west) override;
private:
    void buildChunk(int partionY, Chunk& c, Chunk* north, Chunk* east, Chunk* south, Chunk* west);
    
    const int chunkX = 16;
    const int chunkZ = 16;
    ChunkMesh* mesh;
};

#endif

