#version 430

layout (location = 0) in vec3 pos;
layout (location = 1) in vec4 color;
layout (location = 2) in vec2 tex;
layout (location = 3) in vec3 normal;

uniform sampler2D samp;

uniform mat4 projMatrix;
uniform mat4 viewMatrix;
uniform mat4 modelMatrix;

uniform bool useTexture;
uniform bool useColor;
uniform bool useMixColor;
uniform vec4 mixColor;
uniform bool useNormals;

out vec2 tc;
out vec4 outColor;

void main(void)
{ 
    tc = tex; 
    outColor = vec4(color.xyz, 1);

    if(useNormals)
    {
        if(abs(normal.x) == 1)
        {
            outColor = outColor * 0.8;
        }
        if(abs(normal.z) == 1)
        {
            outColor = outColor * 0.9;
        }
    }
    
    gl_Position = projMatrix * viewMatrix * modelMatrix * vec4(pos, 1.0);
}